﻿namespace vsXPathSDK
{
    /// <summary>
    /// Basic Interface for any plugin used in vsXPathTester
    /// </summary>
    interface IPlugin
    {
        /// <summary>
        /// Name of Plugin
        /// </summary>
        string Name { get; }
        /// <summary>
        /// Support URL for this Plugin
        /// </summary>
        string SupportURL { get; }
        /// <summary>
        /// Plugin Version, no minor or preiod version number supported. Only Main version counted.
        /// </summary>
        int PluginVersion { get; }

        PluginType Type { get; }
    }

    public enum PluginType
    {
        FileFilter,
        ImportExport
    }
}
